# CliffbreakVARO 🗡️

This is the main Repository containing all required resources to compile the Java PaperMC Plugin.  

## Getting Started

The following instructions will get you a copy of the project up and running on your local machine for development and testing purposes. See deployment for notes on how to deploy the project on a live system.

### Prerequisites

`Java 11` is required to compile this project.  

### Installing

First clone this repository to your local machine by using

```
git clone https://git.cliffbreak.de/Cliffbreak/Varo.git
```

Create a new directory named `tmp-build` outside of the project directory (or it will break the VSCode Language Server)

```
mkdir ~/tmp-build && cd ~/tmp-build
```

Download the latest version of Spigot BuildTools
```
wget https://hub.spigotmc.org/jenkins/job/BuildTools/lastSuccessfulBuild/artifact/target/BuildTools.jar
```

Run BuildTools
```
java -jar BuildTools.jar --rev latest
```

After that you can safely remove the `tmp-build` directory
```
rm -rf ~/tmp-build
```

## Configure Visual Studio Code
If you haven't a instance of Visual Studio Code up and running download the latest version [here](https://code.visualstudio.com/download).  
Install the recommended extensions by opening the Extensions-Tab (Ctrl+Shift+X).  
Enter `@recommended` and install all extensions.  
After that restart Visual Studio Code to apply all changes.

## Contributing
First create an issue and assign it to yourself. Or assign an existing issue.  
Make sure all issue details (description, labels, milestones) are correct.  
Check out in a new branch. Notice our convention: use either feature or fix followed by a slash (`/`) and then a **short** description using camel case. (`fix/addMissingImports` or `feature/addBasicAuth`).  
After that you may create a Pull Request to merge your changes into master (If it's work in progress add `WIP:` to the title!).  

## Deployment
In this section you can read details on the deployment cycle.

## Built With

* [OpenJDK](https://openjdk.java.net/) - The Java runtime used to compile the plugin
* [PaperMC](https://papermc.io/javadocs) - The framework used to create the plugin

## Authors

* **Simon Giesel** - *Initial work* - [Simon Giesel](https://git.cliffbreak.de/SimGie)