package de.cliffbreak.varo.commands;

import java.util.HashMap;
import java.util.UUID;

import org.bukkit.Location;
import org.bukkit.command.Command;
import org.bukkit.command.CommandExecutor;
import org.bukkit.command.CommandSender;
import org.bukkit.entity.Player;
import org.bukkit.scheduler.BukkitRunnable;
import org.bukkit.scheduler.BukkitTask;

import de.cliffbreak.varo.Varo;

public class CoordsCommand implements CommandExecutor {

    private final Varo plugin;
    private final HashMap<UUID, BukkitTask> playerCoords;

    public CoordsCommand(final Varo plugin) {
        this.plugin = plugin;
        this.playerCoords = new HashMap<UUID, BukkitTask>();
    }

    @Override
    public boolean onCommand(final CommandSender sender, final Command command, final String label,
            final String[] args) {
        if (sender instanceof Player) {
            final Player p = (Player) sender;
            if (playerCoords.keySet().contains(p.getUniqueId())) {
                playerCoords.get(p.getUniqueId()).cancel();
                playerCoords.remove(p.getUniqueId());
            } else {
                playerCoords.put(p.getUniqueId(), new BukkitRunnable() {
                    @Override
                    public void run() {
                        final Location loc = p.getLocation();
                        p.sendActionBar(String.format("§6§l%d / %d  /  %d", (int) Math.floor(loc.getX()),
                                (int) Math.floor(loc.getY()), (int) Math.floor(loc.getZ())));
                    }
                }.runTaskTimerAsynchronously(this.plugin, 0, 20));
            }
        } else {
            sender.sendMessage(this.plugin.getLangUtils().get("Error.NoPlayer"));
        }
        return true;
    }

}