package de.cliffbreak.varo.commands;

import java.util.ArrayList;
import java.util.List;

import org.bukkit.command.Command;
import org.bukkit.command.CommandSender;
import org.bukkit.command.TabCompleter;

import de.cliffbreak.varo.Varo;

public class VaroTabCompleter implements TabCompleter {

    private final Varo plugin;

    public VaroTabCompleter(final Varo plugin) {
        this.plugin = plugin;
    }

    @Override
    public List<String> onTabComplete(final CommandSender sender, final Command command, final String alias,
            final String[] args) {
        final List<String> list = new ArrayList<String>();
        if (sender.hasPermission("varo.admin")) {
            if (args.length == 1) {
                list.add("unban");
                list.add("ban");
                list.add("heal");
                list.add("portal");
                list.add("addspawns");
            } else if (args.length == 2 && args[0].equals("unban")) {
                final ArrayList<String> bans = this.plugin.getBanUtils().getBans();
                for (String uuid : bans) {
                    list.add(this.plugin.getPlayerCache().getName(uuid));
                }
            } else if (args.length == 2 && (args[0].equals("ban") || args[0].equals("heal"))) {
                return null; // Return null to show default player autocomplete
            } else if (args.length == 2 && args[0].equals("portal")) {
                list.add("enable");
                list.add("disable");
            }
            final List<String> removeQueue = new ArrayList<String>();
            for (String s : list) {
                if (!s.startsWith(args[args.length - 1])) {
                    removeQueue.add(s);
                }
            }
            list.removeAll(removeQueue);
        }
        return list;
    }

}