package de.cliffbreak.varo.database;

import java.sql.Connection;
import java.sql.DriverManager;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Statement;

public class Database {

    private Connection conn;

    public Database() {
        try {
            this.conn = DriverManager.getConnection("jdbc:sqlite:plugins/CliffbreakVaro/players.db");
            this.init();
        } catch (final SQLException e) {
            e.printStackTrace();
        }
    }

    private void init() throws SQLException {
        final Statement s = this.conn.createStatement();
        s.executeUpdate(
                "CREATE TABLE IF NOT EXISTS kills (`player` VARCHAR(32) NOT NULL, `victim` VARCHAR(32) NOT NULL);");
        s.executeUpdate(
                "CREATE TABLE IF NOT EXISTS playercache (`player` VARCHAR(32) NOT NULL, `name` VARCHAR(16), `skinparts` INT(3), `mainhand` VARCHAR(5), `world` TEXT, `x` DOUBLE(4,4), `y` DOUBLE(4,4), `z` DOUBLE(4,4), `pitch` FLOAT(24), `yaw` FLOAT(24));");
        s.close();
    }

    public void shutdown() {
        try {
            this.conn.close();
        } catch (final SQLException e) {
            e.printStackTrace();
        }
    }

    public void addKill(final String uuid, final String victimUuid) {
        try {
            final Statement s = this.conn.createStatement();
            s.executeUpdate("INSERT INTO kills (`player`, `victim`) VALUES ('" + uuid + "', '" + victimUuid + "');");
            s.close();
        } catch (final SQLException e) {
            e.printStackTrace();
        }
    }

    public int getKills(final String uuid) {
        try {
            final Statement s = this.conn.createStatement();
            final ResultSet rs = s.executeQuery("SELECT COUNT(`victim`) FROM kills WHERE `player` ='" + uuid + "';");
            final int kills = rs.getInt("COUNT(`victim`)");
            s.close();
            return kills;
        } catch (final SQLException e) {
            e.printStackTrace();
        }
        return 0;
    }

    public void updatePlayerCache(final String uuid, final String type, final Object value) {
        try {
            final Statement s = this.conn.createStatement();
            if (s.executeUpdate(
                    "UPDATE playercache SET `" + type + "`='" + value + "' WHERE `player`='" + uuid + "';") == 0) {
                s.executeUpdate(
                        "INSERT INTO playercache (`player`, `" + type + "`) VALUES ('" + uuid + "','" + value + "');");
            }
            s.close();
        } catch (final SQLException e) {
            e.printStackTrace();
        }
    }

    public Object getPlayerCache(final String uuid, final String type) {
        try {
            final Statement s = this.conn.createStatement();
            final ResultSet rs = s.executeQuery("SELECT " + type + " FROM playercache WHERE `player` ='" + uuid + "';");
            if (rs.next() == false) {
                return null;
            }
            final Object obj = rs.getObject(type);
            s.close();
            return obj;
        } catch (final SQLException e) {
            e.printStackTrace();
        }
        return null;
    }

}