package de.cliffbreak.varo.discord.filters;

import org.apache.logging.log4j.Level;
import org.apache.logging.log4j.LogManager;
import org.apache.logging.log4j.Marker;
import org.apache.logging.log4j.core.Filter;
import org.apache.logging.log4j.core.LogEvent;
import org.apache.logging.log4j.core.Logger;
import org.apache.logging.log4j.message.Message;
import org.bukkit.Bukkit;

public class JDAFilter implements Filter {

    public Result check(final Logger logger, final Level level, final String message, final Throwable throwable) {
        // only listen for JDA logs
        if (!logger.getName().startsWith("de.cliffbreak.varo.dependencies.jda"))
            return Result.NEUTRAL;

        switch (level.name()) {
        case "INFO":
            Bukkit.getLogger().info("[Discord:INFO] " + message);
            break;
        case "WARN":
            Bukkit.getLogger().warning("[Discord:WARN] " + message);
            break;
        case "ERROR":
            if (message.contains("Got an unexpected error. Please redirect following message to the"))
                return Result.DENY;
            Bukkit.getLogger().warning("[Discord:ERROR] " + message);
            break;
        default:
            Bukkit.getLogger().info("[Discord] " + message);
        }

        // all JDA messages should be denied because we handle them ourselves
        return Result.DENY;
    }

    @Override
    public Result filter(final LogEvent logEvent) {
        return check((Logger) LogManager.getLogger(logEvent.getLoggerName()), logEvent.getLevel(),
                logEvent.getMessage().getFormattedMessage(), logEvent.getThrown());
    }

    @Override
    public Result filter(final Logger logger, final Level level, final Marker marker, final String message,
            final Object... parameters) {
        return check(logger, level, message, null);
    }

    @Override
    public Result filter(final Logger logger, final Level level, final Marker marker, final Object message,
            final Throwable throwable) {
        return check(logger, level, message.toString(), throwable);
    }

    @Override
    public Result filter(final Logger logger, final Level level, final Marker marker, final Message message,
            final Throwable throwable) {
        return check(logger, level, message.getFormattedMessage(), throwable);
    }

    public void start() {
    }

    public void stop() {
    }

    public boolean isStarted() {
        return true;
    }

    public boolean isStopped() {
        return false;
    }

    @Override
    public Result getOnMismatch() {
        return Result.NEUTRAL;
    }

    @Override
    public Result getOnMatch() {
        return Result.NEUTRAL;
    }

    @Override
    public State getState() {
        // Auto-generated method stub
        return null;
    }

    @Override
    public void initialize() {
        // Auto-generated method stub

    }

    @Override
    public Result filter(final Logger arg0, final Level arg1, final Marker arg2, final String arg3, final Object arg4) {
        // Auto-generated method stub
        return null;
    }

    @Override
    public Result filter(final Logger arg0, final Level arg1, final Marker arg2, final String arg3, final Object arg4,
            final Object arg5) {
        // Auto-generated method stub
        return null;
    }

    @Override
    public Result filter(final Logger arg0, final Level arg1, final Marker arg2, final String arg3, final Object arg4,
            final Object arg5, final Object arg6) {
        // Auto-generated method stub
        return null;
    }

    @Override
    public Result filter(final Logger arg0, final Level arg1, final Marker arg2, final String arg3, final Object arg4,
            final Object arg5, final Object arg6, final Object arg7) {
        // Auto-generated method stub
        return null;
    }

    @Override
    public Result filter(final Logger arg0, final Level arg1, final Marker arg2, final String arg3, final Object arg4,
            final Object arg5, final Object arg6, final Object arg7, final Object arg8) {
        // Auto-generated method stub
        return null;
    }

    @Override
    public Result filter(final Logger arg0, final Level arg1, final Marker arg2, final String arg3, final Object arg4,
            final Object arg5, final Object arg6, final Object arg7, final Object arg8, final Object arg9) {
        // Auto-generated method stub
        return null;
    }

    @Override
    public Result filter(final Logger arg0, final Level arg1, final Marker arg2, final String arg3, final Object arg4,
            final Object arg5, final Object arg6, final Object arg7, final Object arg8, final Object arg9,
            final Object arg10) {
        // Auto-generated method stub
        return null;
    }

    @Override
    public Result filter(final Logger arg0, final Level arg1, final Marker arg2, final String arg3, final Object arg4,
            final Object arg5, final Object arg6, final Object arg7, final Object arg8, final Object arg9,
            final Object arg10, final Object arg11) {
        // Auto-generated method stub
        return null;
    }

    @Override
    public Result filter(final Logger arg0, final Level arg1, final Marker arg2, final String arg3, final Object arg4,
            final Object arg5, final Object arg6, final Object arg7, final Object arg8, final Object arg9,
            final Object arg10, final Object arg11, final Object arg12) {
        // Auto-generated method stub
        return null;
    }

    @Override
    public Result filter(final Logger arg0, final Level arg1, final Marker arg2, final String arg3, final Object arg4,
            final Object arg5, final Object arg6, final Object arg7, final Object arg8, final Object arg9,
            final Object arg10, final Object arg11, final Object arg12, final Object arg13) {
        // Auto-generated method stub
        return null;
    }

}