package de.cliffbreak.varo.events;

import org.bukkit.entity.Player;
import org.bukkit.event.Event;
import org.bukkit.event.HandlerList;

import de.cliffbreak.varo.enums.PlayerInteractType;

public class PlayerInteractNPCEvent extends Event {
    private static final HandlerList handlers = new HandlerList();
    private final PlayerInteractType type;
    private final Player damager;
    private final int id;
    private final double damage;
    private final boolean isCritical;

    public PlayerInteractNPCEvent(PlayerInteractType type, Player damager, int id, double damage, boolean isCritical) {
        super(true);
        this.type = type;
        this.damager = damager;
        this.id = id;
        this.damage = damage;
        this.isCritical = isCritical;
    }

    /**
     * @return PlayerInteractType of the Event
     */
    public PlayerInteractType getType() {
        return type;
    }

    /**
     * @return Player who did the Damage
     */
    public Player getDamager() {
        return damager;
    }

    /**
     * @return EntityId of the Event
     */
    public int getId() {
        return id;
    }

    /**
     * @return Damage from Player to Entity (only use if Type=ATTACK)
     */
    public double getDamage() {
        return damage;
    }

    /**
     * @return Return if Player made a critical attack
     */
    public boolean getIsCritical() {
        return isCritical;
    }

    @Override
    public HandlerList getHandlers() {
        return handlers;
    }

    public static HandlerList getHandlerList() {
        return handlers;
    }
}