package de.cliffbreak.varo.listeners;

import org.bukkit.Material;
import org.bukkit.event.EventHandler;
import org.bukkit.event.Listener;
import org.bukkit.event.block.Action;
import org.bukkit.event.player.PlayerInteractEvent;
import org.bukkit.event.world.PortalCreateEvent;

import de.cliffbreak.varo.Varo;

public class BannedActionListener implements Listener {

    private final Varo plugin;

    public BannedActionListener(Varo plugin) {
        this.plugin = plugin;
    }

    @EventHandler
    public void onPortalCreate(final PortalCreateEvent e) {
        if (!this.plugin.canCreatePortal()) {
            e.setCancelled(true);
        }
    }

    @EventHandler
    public void onPlayerInteract(final PlayerInteractEvent e) {
        if (e.getAction().equals(Action.RIGHT_CLICK_BLOCK)) {
            if (e.getClickedBlock().getType().equals(Material.OBSIDIAN)
                    && e.getPlayer().getInventory().getItemInMainHand().getType().equals(Material.FLINT_AND_STEEL)) {
                e.getPlayer().sendMessage(this.plugin.getLangUtils().get("Error.NetherPortalCreate"));
            }
        }
    }

}