package de.cliffbreak.varo.listeners;

import org.bukkit.Material;
import org.bukkit.entity.Player;
import org.bukkit.event.EventHandler;
import org.bukkit.event.Listener;
import org.bukkit.event.entity.EntityPickupItemEvent;
import org.bukkit.event.inventory.InventoryClickEvent;

import de.cliffbreak.varo.Varo;

public class BannedItemListener implements Listener {

    private final Varo plugin;

    public BannedItemListener(final Varo plugin) {
        this.plugin = plugin;
    }

    @EventHandler
    public void onEntityPickupItem(final EntityPickupItemEvent e) {
        if (e.getEntity() instanceof Player) {
            final Material mat = e.getItem().getItemStack().getType();
            if (isForbiddenMaterial(mat)) {
                e.getEntity().sendMessage(this.plugin.getLangUtils().get("Error.BannedItemPickup"));
                e.getItem().remove();
                e.setCancelled(true);
            }
        }
    }

    @EventHandler
    public void onInventoryClick(final InventoryClickEvent e) {
        if (e.getCurrentItem() == null)
            return;
        final Material mat = e.getCurrentItem().getType();
        if (isForbiddenMaterial(mat)) {
            e.getWhoClicked().sendMessage(this.plugin.getLangUtils().get("Error.BannedItemMove"));
            e.setCancelled(true);
        }
    }

    private boolean isForbiddenMaterial(final Material mat) {
        return mat.equals(Material.ENCHANTED_GOLDEN_APPLE) || mat.equals(Material.FISHING_ROD)
                || mat.equals(Material.TOTEM_OF_UNDYING);
    }
}