package de.cliffbreak.varo.listeners;

import org.bukkit.entity.Player;
import org.bukkit.event.EventHandler;
import org.bukkit.event.Listener;
import org.bukkit.event.entity.EntityRegainHealthEvent;

import de.cliffbreak.varo.Varo;

public class EntityRegainHealthListener implements Listener {

    private final Varo plugin;

    public EntityRegainHealthListener(final Varo plugin) {
        this.plugin = plugin;
    }

    @EventHandler
    public void onEntityRegainHealth(final EntityRegainHealthEvent e) {
        if (e.getEntity() instanceof Player) {
            if (this.plugin.getConfig().getBoolean("Varo.RetroHealthRegen")) {
                if (e.isFastRegen()) {
                    e.setAmount(0.13d);
                }
            }
        }
    }
}