package de.cliffbreak.varo.listeners;

import org.bukkit.event.EventHandler;
import org.bukkit.event.Listener;
import org.bukkit.event.player.PlayerLoginEvent;
import org.bukkit.event.player.PlayerLoginEvent.Result;

import de.cliffbreak.varo.Varo;

public class PlayerLoginListener implements Listener {

    private final Varo plugin;

    public PlayerLoginListener(final Varo plugin) {
        this.plugin = plugin;
    }

    @EventHandler
    public void onPlayerLogin(final PlayerLoginEvent e) {
        if (this.plugin.getBanUtils().isBanned(e.getPlayer().getUniqueId())) {
            e.disallow(Result.KICK_BANNED, this.plugin.getLangUtils().get("Service.BannedDead"));
        } else if (!this.plugin.getGameManager().canLogin()) {
            e.disallow(Result.KICK_OTHER, this.plugin.getLangUtils().get("Service.KickNoPlayTime"));
        }
    }
}