package de.cliffbreak.varo.listeners;

import org.bukkit.event.EventHandler;
import org.bukkit.event.Listener;
import org.bukkit.event.player.PlayerResourcePackStatusEvent;
import org.bukkit.event.player.PlayerResourcePackStatusEvent.Status;

import de.cliffbreak.varo.Varo;

public class PlayerResourcePackStatusListener implements Listener {

    private final Varo plugin;

    public PlayerResourcePackStatusListener(final Varo plugin) {
        this.plugin = plugin;
    }

    @EventHandler
    public void onPlayerResourcePackStatus(PlayerResourcePackStatusEvent e) {
        if (e.getStatus().equals(Status.DECLINED)) {
            e.getPlayer().kickPlayer(this.plugin.getLangUtils().get("Error.ResourcepackDeclined"));
        } else if (e.getStatus().equals(Status.FAILED_DOWNLOAD)) {
            e.getPlayer().kickPlayer(this.plugin.getLangUtils().get("Error.ResourcepackFailed"));
        }
    }

}