package de.cliffbreak.varo.utils;

import java.util.ArrayList;
import java.util.UUID;

import de.cliffbreak.varo.Varo;

public class BanUtils {

    private final Varo plugin;

    public BanUtils(final Varo plugin) {
        this.plugin = plugin;
    }

    public boolean isBanned(final UUID uuid) {
        return isBanned(uuid.toString().replace("-", ""));
    }

    public boolean isBanned(final String compressedUuid) {
        @SuppressWarnings("unchecked")
        final ArrayList<String> bans = (ArrayList<String>) this.plugin.getConfig().get("Varo.Bans");
        return bans.contains(compressedUuid);
    }

    public ArrayList<String> getBans() {
        @SuppressWarnings("unchecked")
        final ArrayList<String> bans = (ArrayList<String>) this.plugin.getConfig().get("Varo.Bans");
        return bans;
    }

    public void addBan(final UUID uuid) {
        addBan(uuid.toString().replace("-", ""));
    }

    public void addBan(final String compressedUuid) {
        @SuppressWarnings("unchecked")
        final ArrayList<String> bans = (ArrayList<String>) this.plugin.getConfig().get("Varo.Bans");
        if (!bans.contains(compressedUuid)) {
            bans.add(compressedUuid);
            this.plugin.getConfig().set("Varo.Bans", bans);
            this.plugin.saveConfig();
        }
    }

    public void removeBan(final String compressedUuid) {
        @SuppressWarnings("unchecked")
        final ArrayList<String> bans = (ArrayList<String>) this.plugin.getConfig().get("Varo.Bans");
        bans.remove(compressedUuid);
        this.plugin.getConfig().set("Varo.Bans", bans);
        this.plugin.saveConfig();
    }

}