package de.cliffbreak.varo.utils;

import java.io.File;
import java.io.FileInputStream;
import java.util.HashMap;
import java.util.Map;

import org.bukkit.Bukkit;
import org.bukkit.Material;
import org.bukkit.World;
import org.bukkit.enchantments.Enchantment;
import org.bukkit.inventory.ItemStack;

import net.minecraft.server.v1_15_R1.NBTCompressedStreamTools;
import net.minecraft.server.v1_15_R1.NBTTagCompound;
import net.minecraft.server.v1_15_R1.NBTTagList;

public class ImprovedOfflinePlayer {
    private String player;
    private File file;
    private NBTTagCompound compound;
    private boolean exists = true;
    private String pluginName;

    public ImprovedOfflinePlayer(String name) {
        this.player = name;
        loadOfflinePlayer();
    }

    private void loadOfflinePlayer() {
        try {
            for (World w : Bukkit.getWorlds()) {
                File check = new File(w.getWorldFolder(), "playerdata" + File.separator + this.player + ".dat");
                if (check.exists()) {
                    this.exists = true;
                    this.file = check;
                    this.compound = NBTCompressedStreamTools.a(new FileInputStream(this.file));
                    this.pluginName = ImprovedOfflinePlayer.class.getProtectionDomain().getCodeSource().toString();
                    this.pluginName = this.pluginName.substring(this.pluginName.lastIndexOf("/") + 1,
                            this.pluginName.lastIndexOf("."));
                    return;
                }
                this.exists = false;
            }
        } catch (Exception e) {
            this.exists = false;
        }
    }

    public ItemStack[] getInventoryItems() {
        ItemStack[] items = new ItemStack[36];
        if (!this.exists) {
            return items;
        }
        NBTTagList list = this.compound.getList("Inventory", 10);
        System.out.println(list);
        for (int i = 0; i < list.size(); i++) {
            NBTTagCompound item = (NBTTagCompound) list.get(i);
            byte slot = item.getByte("Slot");
            String id = item.getString("id");
            byte count = item.getByte("Count");
            short damage = item.getShort("Damage");
            System.out.println(id);
            System.out.println(slot);

            if (slot < 100 && slot >= 0) {
                items[slot] = new ItemStack(Material.matchMaterial(id), count);
                items[slot].setDurability(damage);
                if (item.hasKey("tag")) {
                    Map<Enchantment, Integer> enchantments = new HashMap<Enchantment, Integer>();
                    NBTTagCompound tCompound = item.getCompound("tag");
                    if (tCompound.hasKey("ench")) {
                        NBTTagList enchTL = tCompound.getList("ench", 10);
                        for (int f = 0; f < enchTL.size(); f++) {
                            NBTTagCompound enchTC = (NBTTagCompound) tCompound.getList("ench", 10).get(f);
                            String idTC = enchTC.getString("id");
                            short lvlTC = enchTC.getShort("lvl");
                            enchantments.put(Enchantment.getByName(idTC), (int) lvlTC);
                        }
                    }
                    items[slot].addUnsafeEnchantments(enchantments);
                }
            }
        }
        return items;
    }
}