package de.cliffbreak.varo.utils;

import java.io.File;
import java.io.IOException;

import org.bukkit.configuration.file.YamlConfiguration;

public class LangUtils {
        private final File file;
        private final YamlConfiguration config;

        public LangUtils() {
                this.file = new File("plugins/CliffbreakVaro", "lang.yml");
                this.config = YamlConfiguration.loadConfiguration(this.file);

                this.config.addDefault("Service.KickNoPlayTime",
                                "§4Außerhalb der Spielzeit.\n \n§6Versuche es später erneut.");
                this.config.addDefault("Service.KickPlayTimeOver",
                                "§4Die Spielzeit ist abgelaufen.\n \n§6Bis morgen :)");
                this.config.addDefault("Service.LoadingTitle", "§a§lVaro 2020");
                this.config.addDefault("Service.LoadingSubTitle", "Das Spiel startet gleich...");
                this.config.addDefault("Service.PreStartTitle", "In %seconds% Sekunden geht es los.");
                this.config.addDefault("Service.LoadingCountdown", "§r§l Noch: %02d:%02d");
                this.config.addDefault("Service.BannedDead",
                                "§4Du bist gestorben.\n \n§cDamit bist du aus §eVaro§c ausgeschieden.");
                this.config.addDefault("Service.Protection",
                                " §aDie Schutzzeit ist in §2§l%minutes% Minuten§r§a vorbei. §r§7§o#staysafe");
                this.config.addDefault("Service.ProtectionOver",
                                " §c§lAchtung: §r§aDie Schutzzeit ist§2§l JETZT§r§a vorbei. §r§7§o#staysafe");
                this.config.addDefault("Error.NoPlayer",
                                "§c§lFehler:§r§c Dieses Kommando kann nur durch einen Spieler ausgeführt werden.");
                this.config.addDefault("Error.ResourcepackDeclined",
                                "§4Du wurdest gekickt.\n \n§r§7Aktiviere §f§lRessourcepacks§r§7 in den\n§f§lServer-Einstellungen§r§7, um spielen zu können.\n \nBei Problemen kontaktiere die §f§l@Admins §r§7auf dem Discord-Server.");
                this.config.addDefault("Error.ResourcepackFailed",
                                "§4Du wurdest gekickt.\n \n§r§7Das §f§lServer-Ressourcepack §r§7konnte\n§r§7nicht erfolgreich heruntergeladen werden.\n \nBitte versuche es erneut.\n \nBei Problemen kontaktiere die §f§l@Admins §r§7auf dem Discord-Server.");
                this.config.addDefault("Error.NoTeam",
                                "§4§lFehler!\n \n§cDu bist keinem Team zugeordnet.\n \n§r§7Kontaktiere bitte die §f§l@Admins §r§7auf dem Discord-Server.");
                this.config.addDefault("Error.Brew", "§cEs kann nur ein Heilungstrank gebraut werden.");
                this.config.addDefault("Error.BannedItemMove",
                                "§cVerbotenes Item kann nicht ins Inventar verschoben werden.");
                this.config.addDefault("Error.BannedItemPickup", "§cVerbotenes Item wurde entfernt.");
                this.config.addDefault("Error.NetherPortalCreate",
                                "§cUm in den Nether zu gelangen nutze das Portal in der Mitte.\n §rGehe hierzu in die Mitte.");
                this.config.addDefault("Discord.BorderUpdate",
                                "@everyone In 30 Minuten geht es los!\nDie Border schrumpft heute auf %size%x%size% Blöcke.");
                this.config.addDefault("Discord.PlayerStats", "Der Spieler <@!%id%> hat momentan %kills% Kills.");
                this.config.addDefault("Discord.PlayerDeath", "Der Spieler <@!%id%> ist gestorben.");
                this.config.addDefault("Discord.PlayerDeathKiller",
                                "Der Spieler <@!%id%> wurde von <@!%id_killer%> getötet.");
                this.config.addDefault("Death.CUSTOM", "%player% ist gestorben.");
                this.config.addDefault("Death.CUSTOMkiller", "%player% wurde von %killer% getötet.");
                this.config.addDefault("Death.BLOCK_EXPLOSION", "%player% ist explodiert.");
                this.config.addDefault("Death.BLOCK_EXPLOSIONkiller",
                                "%player% ist im Kampf gegen %killer% explodiert.");
                this.config.addDefault("Death.CONTACT", "%player% ist gestorben.");
                this.config.addDefault("Death.CONTACTkiller", "%player% wurde von %killer% getötet.");
                this.config.addDefault("Death.DROWNING", "%player% ist ertrunken.");
                this.config.addDefault("Death.DROWNINGkiller", "%player% wurde von %killer% im Kampf ertränkt.");
                this.config.addDefault("Death.ENTITY_EXPLOSION", "%player% ist gestorben.");
                this.config.addDefault("Death.ENTITY_EXPLOSIONkiller", "%player% wurde von %killer% getötet.");
                this.config.addDefault("Death.ENTITY_ATTACK", "%player% ist gestorben.");
                this.config.addDefault("Death.ENTITY_ATTACKkiller", "%player% wurde von %killer% getötet.");
                this.config.addDefault("Death.FALL", "%player% fiel aus zu großer Höhe");
                this.config.addDefault("Death.FALLkiller", "%player% wurde von %killer% getötet.");
                this.config.addDefault("Death.FALLING_BLOCK", "%player% wurde von einem fallenden Block zerquetscht.");
                this.config.addDefault("Death.FALLING_BLOCKkiller", "%player% wurde von %killer% getötet.");
                this.config.addDefault("Death.FIRE", "%player% ging in Flammen auf.");
                this.config.addDefault("Death.FIREkiller", "%player% wurde von %killer% getötet.");
                this.config.addDefault("Death.HOT_FLOOR", "%player% ist gestorben.");
                this.config.addDefault("Death.HOT_FLOORkiller", "%player% wurde von %killer% getötet.");
                this.config.addDefault("Death.LAVA", "%player% versuchte in Lava zu schwimmen.");
                this.config.addDefault("Death.LAVAkiller", "%player% wurde von %killer% getötet.");
                this.config.addDefault("Death.LIGHTNING", "%player% wurde vom Blitz getroffen.");
                this.config.addDefault("Death.LIGHTNINGkiller", "%player% wurde von %killer% getötet.");
                this.config.addDefault("Death.MAGIC", "%player% wurde durch Magie getötet.");
                this.config.addDefault("Death.MAGICkiller", "%player% wurde von %killer% mit Magie getötet.");
                this.config.addDefault("Death.POISON", "%player% ist gestorben.");
                this.config.addDefault("Death.POISONkiller", "%player% wurde von %killer% getötet.");
                this.config.addDefault("Death.PROJECTILE", "%player% ist gestorben.");
                this.config.addDefault("Death.PROJECTILEkiller", "%player% wurde von %killer% getötet.");
                this.config.addDefault("Death.STARVATION", "%player% ist verhungert.");
                this.config.addDefault("Death.STARVATIONkiller", "%player% verhungerte während dem Kamp mit %killer%.");
                this.config.addDefault("Death.SUFFOCATION", "%player% wurde lebendig begraben.");
                this.config.addDefault("Death.SUFFOCATIONkiller", "%player% wurde von %killer% getötet.");
                this.config.addDefault("Death.THORNS", "%player% ist gestorben.");
                this.config.addDefault("Death.THORNSkiller",
                                "%player% wurde beim Versuch %killer% zu verletzen getötet.");
                this.config.addDefault("Death.VOID", "%player% ist gestorben.");
                this.config.addDefault("Death.VOIDkiller", "%player% wurde von %killer% getötet.");
                this.config.addDefault("Death.WITHER", "%player% ist gestorben.");
                this.config.addDefault("Death.WITHERkiller", "%player% wurde von %killer% getötet.");
                this.config.options().copyDefaults(true);
                this.saveConfig();
        }

        public String get(final String path) {
                return this.config.getString(path);
        }

        private void saveConfig() {
                try {
                        this.config.save(this.file);
                } catch (final IOException e) {
                        e.printStackTrace();
                }
        }
}